<?php
namespace Suprimentos\Logic\FornecedorAtende;

use \Geral\Util\Ambiente;
use \Setforms2\Shared\Registry;
use \Suprimentos\Logic\FornecedorAtende\OperacoesSQL;
use \Suprimentos\Repositories;
use \Suprimentos\Logic\FornecedorAtende\Exception\Exception;
use \Geral\Util\TratamentoDeMensagens;

class opAtende extends OperacoesSQL{

    const OBJ_VAZIO=0;
    const OBJ_NVAZIO=1;
    const OBJ_PERIOD=2;

    public static function redefine($modo, $nrorg, $cdfilial, $cdforneced, $peridiocidade=''){
        try {
            switch ($modo) {
                case (self::MODO_INSERE):
                {
                    switch (self::busca($nrorg, $cdfilial, $cdforneced)) {
                        case (self::OBJ_VAZIO):
                        {
                            if ($peridiocidade != '') {
                                self::insere($nrorg, $cdfilial, $cdforneced, $peridiocidade);
                            } else {
                                /**************** MENSAGEM DE ERRO! >> JÁ EXISTE O REGISTRO! ***************/
                                Exception::regExist();
                            }
                            break;
                        }
                        case (self::OBJ_NVAZIO):
                        {
                            if ($peridiocidade != '') {
                                self::modifica($nrorg, $cdfilial, $cdforneced, $peridiocidade);
                            } else {
                                self::delete($nrorg, $cdfilial, $cdforneced);
                            }
                            break;
                        }
                        case (self::OBJ_PERIOD):
                        {
                            /**************** MENSAGEM DE ERRO! >> JÁ EXISTE O REGISTRO! ***************/
                            Exception::regExist();
                            break;
                        }
                        default:{
                            /**************** MENSAGEM DE ERRO! >> ERRO AO EXECULTAR AÇÃO. ATUALIZE A PÁGINA E TENTE NOVAMENTE! ***************/
                            Exception::execAcao();
                            break;
                        }
                    }
                    break;
                }
                case (self::MODO_DELETE):
                {
                    switch (self::busca($nrorg, $cdfilial, $cdforneced)) {
                        case self::OBJ_VAZIO:
                        {
                            self::insere($nrorg, $cdfilial, $cdforneced);
                            break;
                        }
                        case (self::OBJ_NVAZIO):
                        {
                            /**************** MENSAGEM DE ERRO! >> FORNECEDOR NAO ATENDE A ÁREA! ***************/
                            Exception::naoAtende();
                            break;
                        }
                        case (self::OBJ_PERIOD):
                        {
                            self::modifica($nrorg, $cdfilial, $cdforneced);
                            break;
                        }
                        default:
                            {
                            /**************** MENSAGEM DE ERRO! >> ERRO AO EXECULTAR AÇÃO. ATUALIZE A PÁGINA E TENTE NOVAMENTE! ***************/
                            Exception::execAcao();
                            break;
                            }
                    }
                    break;
                }
                case (self::MODO_UPDATE):
                {
                    switch (self::busca($nrorg, $cdfilial, $cdforneced)) {
                        case (self::OBJ_PERIOD):
                        {
                            if ($peridiocidade) {
                                self::modifica($nrorg, $cdfilial, $cdforneced, $peridiocidade);
                            } else {
                                self::delete($nrorg, $cdfilial, $cdforneced);
                            }
                            break;
                        }
                        case (self::OBJ_VAZIO):{
                            if($peridiocidade)
                                self::insere($nrorg, $cdfilial, $cdforneced, $peridiocidade);
                            else
                                /**************** MENSAGEM DE ERRO! >> NÃO EXISTE O REGISTRO! ***************/
                                Exception::regExist();
                            break;
                        }
                        default:
                            {
                            /**************** MENSAGEM DE ERRO! >> NÃO EXISTE O REGISTRO! ***************/
                            Exception::naoAtende();
                            break;
                            }
                    }
                    break;
                }
                default:
                    {
                    /**************** MENSAGEM DE ERRO! >> OPERAÇÃO NÃO DEFINIDA. ***************/
                    Exception::execAcao();
                    break;
                    }
            }
        } catch (\Exception $e) {
            throw $e;
        }
    }
}