package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;
import org.openqa.selenium.interactions.Actions;
import org.testng.Assert;

public class UnidadeAdicionalProdutoPage extends PageBase {

    By botaoMenu = By.xpath("//div[@class='bars']");
    By campoPesquisar = By.xpath("//section[@class='zh-container-search-menu']//input[@type='text']");
    By telaUnidadeAdicionalProduto = By.xpath("//span[text() = 'Unidade Adicional do Produto']");

    By botaoAdicionarTelaInicial = By.xpath("//li[@data-zh-id=\"18945071144253883066836\"]");
    By botaoExcluirTelaInicial = By.xpath("//li[@data-zh-id=\"18945071143694378994838\"]");
    By botaoSalvar = By.xpath("//div[@class=\"zh-footer-right\"]");
    By botaoCancelar = By.xpath("//div[@class=\"zh-footer-left\"]");
    By botaoVoltar = By.xpath("//div[@class=\"zh-footer-left\"]");
    By botaoEditarConversao = By.xpath("//li[@data-zh-id=\"18945071141755128836779\"]");
    By botaoExcluirConversao = By.xpath("//li[@data-zh-id=\"18945071144129244251781\"]");
    By botaoAdicionarConversao = By.xpath("//li[@data-zh-id=\"18945071144231460928777\"]");

    By botaoCampoProduto = By.xpath("//div[@id=\"NMPRODUTO\"]//span[@style=\"background-image: none; display: block;\"]");
    By campoProcurar = By.xpath("//li[@class=\"float-action expandable fix-position-bottom opened\"]//input[@placeholder=\"Procurar\"]");
    By produtoIodetoArsenio = By.xpath("//div[@data-zh-field-name=\"NMPRODUTO\"]//span[text() = 'IODETO DE ARSENIO']");
    By botaoCampoUnidadeSecundaria = By.xpath("//div[@id=\"DSUNIDADE\"]//span[@style=\"background-image: none; display: block;\"]");
    By unidadeSecundariaLata = By.xpath("//div[@data-zh-field-name=\"DSUNIDADE\"]//span[text() = 'LATA']");
    By unidadeSecundariaPote = By.xpath("//div[@data-zh-field-name=\"DSUNIDADE\"]//span[text() = 'POTE']");
    By primeiraOpcaoRelacao = By.xpath("//div[@data-zh-id=\"18945071142730958612767\"]//label[@for=\"radio-OPCOES_RELACAO-0\"]/div");
    By segundaOpcaoRelacao = By.xpath("//div[@data-zh-id=\"18945071142730958612767\"]//label[@for=\"radio-OPCOES_RELACAO-1\"]/div");
    By campoRelacao = By.id("VRFATOCONVES");
    By mensagemObrigatorioProduto = By.xpath("//div[@data-zh-id=\"1894507114369353165793\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioUnidadeSecundaria = By.xpath("//div[@data-zh-id=\"18945071143976275161799\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioRelacao = By.xpath("//div[@data-zh-id=\"1894507114568765171805\"]//div[@class=\"zh-validation\"]/span");

    By codigoTelaInicial = By.xpath("//div[@id=\"grid-18945071142751037915754\"]//div[@class=\"body-content\"]/div/div[1]/span");
    By produtoTelaInicial = By.xpath("//div[@id=\"grid-18945071142751037915754\"]//div[@class=\"body-content\"]/div/div[2]/span");
    By unidadeTelaInicial = By.xpath("//div[@id=\"grid-18945071142751037915754\"]//div[@class=\"body-content\"]/div/div[3]/span");
    By descricaoConversaoUnidade = By.xpath("//div[@id=\"grid-1894507114884518294756\"]//div[@class=\"body-content\"]/div[1]/div[1]/span");
    By descricaoSegundaConversaoUnidade = By.xpath("//div[@id=\"grid-1894507114884518294756\"]//div[@class=\"body-content\"]/div[2]/div[1]/span");

    By mensagemSucesso = By.xpath("//*[@class=\"zh-notification-messages\"]//span[@class=\"notification-message-text\"]");
    By mensagemAlerta = By.xpath("//section[@class=\"zh-container-alert\"]//p[@class=\"zh-text-alert\"]");
    By botaoSimMensagemAlerta = By.xpath("//section[@class=\"zh-container-alert\"]//footer[@class=\"zh-footer-alert\"]/button[1]");
    By botaoOk = By.xpath("//section[@class=\"zh-container-alert\"]//button[@data-ng-repeat=\"button in buttons\"]");

    public void acessarTela() {
        tempoParaAguardarTelaInicial();
        waitForElement(botaoMenu);
        click(botaoMenu);
        sendKeys(campoPesquisar, "Unidade Adicional do Produto");
        click(telaUnidadeAdicionalProduto);
        tempoParaAguardarTelaInicial();
    }

    public void adicionarUnidadeAdicional() {
        click(botaoAdicionarTelaInicial);
        click(botaoCampoProduto);
        sendKeys(campoProcurar, "IODETO DE ARSENIO");
        click(produtoIodetoArsenio);
        click(botaoCampoUnidadeSecundaria);
        sendKeys(campoProcurar, "LATA");
        click(unidadeSecundariaLata);
        sendKeys(campoRelacao, "0,5");
        click(botaoSalvar);

        String mensagem = getText(mensagemSucesso);
        Assert.assertEquals(mensagem, "Salvo com sucesso", "Verificação da mensagem de salvo com sucesso");
        tempo();

        //valores encontrados na tela inicial após adicionar undidade
        String encCodigo = getText(codigoTelaInicial);
        String encProduto = getText(produtoTelaInicial);
        String encUnidade = getText(unidadeTelaInicial);

        //valores esperados
        String expCodigo = "1.01.1.1.02.014.00";
        String expProduto = "IODETO DE ARSENIO";
        String expUnidade = "KG";

        Assert.assertEquals(encCodigo, expCodigo, "Verificação do código do produto");
        Assert.assertEquals(encProduto, expProduto, "Verificação do nome do produto");
        Assert.assertEquals(encUnidade, expUnidade, "Verificação da unidade do produto");
    }

    public void verificarConversaoDeUnidade() {
        click(produtoTelaInicial);

        String descricaoConversao = getText(descricaoConversaoUnidade);
        String descricaoEsperada = "1 LATA equivale a 2 QUILOGRAMA(s).";
        Assert.assertEquals(descricaoConversao, descricaoEsperada, "Verificação da mensagem de descrição da conversão da unidade adicionada");

        click(botaoEditarConversao);
        click(primeiraOpcaoRelacao);
        String valorRelacao = driver.findElement(campoRelacao).getAttribute("value");
        String valorEsperado = "0,500";
        Assert.assertEquals(valorRelacao, valorEsperado, "Verificação do valor da relação da primeira unidade secundária adicionada. O valor é referente à primeira opção de relação");

        click(segundaOpcaoRelacao);
        valorRelacao = driver.findElement(campoRelacao).getAttribute("value");
        valorEsperado = "2,000";
        Assert.assertEquals(valorRelacao, valorEsperado, "Verificação do valor da relação da primeira unidade secundária adicionada. O valor é referente à segunda opção de relação");
        click(botaoCancelar);
    }

    public void editarConversao() {
        tempo();
        click(botaoEditarConversao);
        tempo();
        String valorRelacao = driver.findElement(campoRelacao).getAttribute("value");
        String valorEsperado = "0,500";
        Assert.assertEquals(valorRelacao, valorEsperado, "Verificação do valor da relação, antes da edição");

        clear(campoRelacao);
        sendKeys(campoRelacao, "1,5");
        click(botaoSalvar);

        click(botaoEditarConversao);
        valorRelacao = driver.findElement(campoRelacao).getAttribute("value");
        valorEsperado = "1,500";
        Assert.assertEquals(valorRelacao, valorEsperado, "Verificação do valor da relação, após a edição");
        tempo();
        click(botaoCancelar);
    }

    public void adicionarSegundaConversao() {
        tempo();
        click(botaoAdicionarConversao);
        click(botaoCampoUnidadeSecundaria);
        sendKeys(campoProcurar, "POTE");
        click(unidadeSecundariaPote);
        sendKeys(campoRelacao, "3,2");
        click(botaoSalvar);

        tempo();
        int posicaoConversaoLinha;
        String descricaoSegundaConversao = getText(descricaoSegundaConversaoUnidade);
        String descricaoEsperada = "1 POTE equivale a 0.3125 QUILOGRAMA(s).";

        if (descricaoSegundaConversao.equals(descricaoEsperada)) {
            posicaoConversaoLinha = 2;
            Assert.assertEquals(descricaoSegundaConversao, descricaoEsperada, "Verificação da descrição da segunda conversão de unidade realizada");
        } else {
            posicaoConversaoLinha = 1;
            descricaoSegundaConversao = getText(descricaoConversaoUnidade);
            Assert.assertEquals(descricaoSegundaConversao, descricaoEsperada, "Verificação da descrição da segunda conversão de unidade realizada");
        }

        if (posicaoConversaoLinha == 1) click(descricaoConversaoUnidade);
        else click(descricaoSegundaConversaoUnidade);

        click(botaoEditarConversao);
        tempo();
        String valorRelacao = driver.findElement(campoRelacao).getAttribute("value");
        String valorEsperado = "3,200";
        Assert.assertEquals(valorRelacao, valorEsperado, "Verificação do valor da relação, da segunda conversão realizada");
        click(botaoCancelar);
    }

    public void excluirConversao() {
        tempo();
        click(descricaoConversaoUnidade);
        click(botaoExcluirConversao);

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Remover registro?";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação da mensagem que aparece na tela após solicitar a remoção da conversão");
        click(botaoSimMensagemAlerta);

        mensagem = getText(mensagemAlerta);
        mensagemEsperada = "Removido com sucesso";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação da mensagem de sucesso após a exclusão da conversão");
        click(botaoOk);
    }

    public void excluirUnidadeAdicionalProdutoIodeto() {
        click(botaoExcluirTelaInicial);

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Deseja excluir o produto IODETO DE ARSENIO e todas as suas conversões?";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação da mensagem de alerta exibida na tentativa de excluir toda a unidade adicional do produto IODETO DE ARSENIO");
        click(botaoSimMensagemAlerta);

        mensagem = getText(mensagemAlerta);
        mensagemEsperada = "Removido com sucesso";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação da mensagem de sucesso após a exclusão da unidade adicional do produto IODETO DE ARSENIO");
        click(botaoOk);
    }

    public void tentarEscreverTextoCampoNumerico() {
        click(botaoAdicionarTelaInicial);
        tempo();

        Actions actions = new Actions(driver);
        actions.sendKeys(driver.findElement(campoRelacao), "abc#@5,9").build().perform();
        tempo();
        click(botaoSalvar);

        String relacao = driver.findElement(campoRelacao).getAttribute("value");

        Assert.assertEquals(relacao, "5,900", "teste texto");
    }

    public void camposObrigatorios() {
        click(botaoAdicionarTelaInicial);
        tempo();
        click(botaoSalvar);

        String produto = getText(mensagemObrigatorioProduto);
        String unidadeSecundaria = getText(mensagemObrigatorioUnidadeSecundaria);
        String relacao = getText(mensagemObrigatorioRelacao);

        String mensagemEsperada = "Campo obrigatório";
        Assert.assertEquals(produto, mensagemEsperada, "Verificação da mensagem de campo obritório do campo produto");
        Assert.assertEquals(unidadeSecundaria, mensagemEsperada, "Verificação da mensagem de campo obritório do campo unidade secundária");
        Assert.assertEquals(relacao, mensagemEsperada, "Verificação da mensagem de campo obritório do campo relação");
    }

}
