package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.CadastroPratoFlows;
import com.javaseleniumtemplate.flows.CadastroServicoFlows;
import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.pages.CadastroServicoPage;
import org.testng.Assert;
import org.testng.annotations.Test;

public class CadastroServicoTests extends TestBase {
    CadastroServicoFlows cadastroServicoFlows;
    CadastroServicoPage cadastroServicoPage;
    LoginFlows loginFlows;
    String cdUnidade = "0002";

    public void navegaServico () {
        cadastroServicoFlows = new CadastroServicoFlows();
        cadastroServicoPage = new CadastroServicoPage();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        cadastroServicoFlows.navegarPaginaServico(cdUnidade);
    }

    @Test
    public void cadastroServico() {
        cadastroServicoFlows = new CadastroServicoFlows();
        cadastroServicoPage = new CadastroServicoPage();
        loginFlows = new LoginFlows();

        String codigoServico = "00012";
        String nomeServico = "ALMOÇO AUTOMAÇÃO";
        String nomeReduzido = "ALMOÇO";
        String nomeFantasia = "ALMOÇO";
        String horaPreparo = "05:00";
        String nomeProduto = "CREOSOTO";
        String valorCusto = "1,20";

        //comenais do serviço
        String QTCOMESTISEG = "20";
        String QTCOMESTITER = "20";
        String QTCOMESTIQUA = "20";
        String QTCOMESTIQUI = "20";
        String QTCOMESTISEX = "20";

        String NMCLIENTE = "DROGARIA FIBERSAL";

        //comenais ponto de entrega
        String QTDCOESTCSSEG = "20";
        String QTDCOMESTITER = "20";
        String QTDCOMESTIQUA = "20";
        String QTDCOESTCSQUI = "20";
        String QTDCOMESTISEX = "20";

        //Serviço/Produto de Faturamento
        String CDSERVICO = "00001";
        String NMPRODUTO = "CREOSOTO";
        String VALPERCENT = "100";

        //Embalagens
        String NMPONTOENTREGA = "DROGARIA FIBERSAL";
        String NMEMBALAGEM = "DISTRIBUICAO AUTOMATICA";

        loginFlows.efetuarLogin();
        cadastroServicoFlows.navegarPaginaServico(cdUnidade);
        cadastroServicoPage.insereInformacoes(codigoServico, nomeServico, nomeReduzido, nomeFantasia, horaPreparo);

        cadastroServicoFlows.marcaParametros(nomeProduto);

        cadastroServicoPage.configuraCardapio();
        cadastroServicoPage.custoPadrao(valorCusto);
        cadastroServicoPage.informaComensais(QTCOMESTISEG, QTCOMESTITER, QTCOMESTIQUA, QTCOMESTIQUI, QTCOMESTISEX);

        cadastroServicoPage.pontoDeEntrega(NMCLIENTE);
        cadastroServicoPage.comensaisPontoEntrega(QTDCOESTCSSEG, QTDCOMESTITER, QTDCOMESTIQUA, QTDCOESTCSQUI, QTDCOMESTISEX);
        cadastroServicoFlows.abaFaturamento(CDSERVICO, NMPRODUTO, VALPERCENT);


        cadastroServicoFlows.abaEmbalagens(NMPONTOENTREGA, NMEMBALAGEM);

        Assert.assertTrue(cadastroServicoPage.validaCadastroServico().contains(codigoServico));

    }

    @Test
    public void manutencaoCustoPadrao(){
        navegaServico();
        cadastroServicoFlows.manutencaoCustoPadrao();}

    @Test
    public void cadastrarTurno(){
        navegaServico();
        String NMTURNO1 = "Manhã";
        String QTCOESTCSSEG = "100";
        String QTCOESTCSTER = "100";
        String QTCOESTCSQUA = "100";
        String QTCOESTCSQUI = "100";
        String QTCOESTCSSEX = "100";
        String NMTURNO2 = "Tarde";
        String QTCOESTCSSEG2 = "100";
        String QTCOESTCSTER2 = "100";
        String QTCOESTCSQUA2 = "100";
        String QTCOESTCSQUI2 = "100";
        String QTCOESTCSSEX2 = "100";

        cadastroServicoFlows.cadastrarTurno(NMTURNO1,QTCOESTCSSEG,QTCOESTCSTER,QTCOESTCSQUA,QTCOESTCSQUI,QTCOESTCSSEX,
                NMTURNO2,QTCOESTCSSEG2,QTCOESTCSTER2,QTCOESTCSQUA2,QTCOESTCSQUI2,QTCOESTCSSEX2);
    }

    @Test
    public void alteraComensalTurno(){
        navegaServico();
        String QTCOESTCSSEG = "50";
        String QTCOESTCSTER = "50";
        String QTCOESTCSQUA = "50";
        String QTCOESTCSQUI = "50";
        String QTCOESTCSSEX = "50";
        String QTCOESTCSSEG2 = "50";
        String QTCOESTCSTER2 = "50";
        String QTCOESTCSQUA2 = "50";
        String QTCOESTCSQUI2 = "50";
        String QTCOESTCSSEX2 = "50";

        cadastroServicoFlows.alterarComensaisTurno(QTCOESTCSSEG,QTCOESTCSTER,QTCOESTCSQUA,QTCOESTCSQUI,QTCOESTCSSEX,
                QTCOESTCSSEG2,QTCOESTCSTER2,QTCOESTCSQUA2,QTCOESTCSQUI2,QTCOESTCSSEX2);
    }

    @Test
    public void excluirTurno(){
        String MSGESPERADA = "Não há registros";
        navegaServico();
        cadastroServicoFlows.excluindoTurno();
        Assert.assertEquals(MSGESPERADA,cadastroServicoFlows.validarExclusaoTurno(),"Validando Se o Tuno foi apagago: ");
    }

    @Test
    public void exportaComensais(){

        navegaServico();
        String DTINICIAL = "01/05/2023";
        String DTFINAL = "30/05/2023";
        cadastroServicoFlows.exportaComensais(DTINICIAL, DTFINAL);


    }

    @Test
    public void alteraComensaisCliente(){
        navegaServico();
        String QTCOESTCSSEG = "100";
        String QTCOESTCSTER = "100";
        String QTCOESTCSQUA = "100";
        String QTCOESTCSQUI = "100";
        String QTCOESTCSSEX = "100";
        cadastroServicoFlows.alteraComensaisPontoEntrega(QTCOESTCSSEG,QTCOESTCSTER,QTCOESTCSQUA,QTCOESTCSQUI,QTCOESTCSSEX);
    }

    @Test
    public void excluirEmbalagemPontoEntrega(){
        navegaServico();
        String NMPONTOENTREGA = "DROGARIA FIBERSAL";
        cadastroServicoFlows.excluirEmbalagemPontoEntrega(NMPONTOENTREGA);
    }

    @Test
    public void excluirPontoEntrega(){
         navegaServico();
        cadastroServicoFlows.apagaPontoEntrega();
    }

    @Test
    public void alterarProdutoFaturamento(){
        navegaServico();
        String CDPRODFATU = "101110100201";
        String NMPRODUTO = "OLEO DE CASTANHA DO BRASIL EMBALAGEM 1 LITRO";
        cadastroServicoFlows.alteraProdutoFaturamento(CDPRODFATU);
        Assert.assertEquals(NMPRODUTO,cadastroServicoFlows.validaProdutoAlterado(),"Valida se o produto foi alterado corretamente: ");

    }

    @Test
    public void excluirServicoProdutoFaturamento(){
        navegaServico();
        String mensagemEsperada = "Não há registros";
        cadastroServicoFlows.apagaServicoProdutoFaturamento();
        Assert.assertTrue(cadastroServicoPage.validaExclusao().contains(mensagemEsperada));
    }

    @Test
    public void importaEmbalagem(){
        navegaServico();
        String CDFILORIG = "0003";
        cadastroServicoFlows.importaEmbalagens(CDFILORIG);

    }

    @Test
    public void importaEmbalagemPontoEntrega(){
        navegaServico();
        String CDUNIDADE = "0003";
        cadastroServicoFlows.importaEmbalagemPontoEntrega(CDUNIDADE);
    }

    @Test
    public void exportaEmbalagem(){
        navegaServico();
        String CDFILIAL = "0003";
        String confirmaExportacao = "DISTRIBUIÇÃO AUTOMÁTICA RECURSIVA";
        cadastroServicoFlows.exportaEmbalagem(CDFILIAL);
        Assert.assertTrue(cadastroServicoPage.validaExportacaoEmbalagem().contains(confirmaExportacao));
    }

    @Test
    public void excluirPontoDeEntrega(){
        navegaServico();
        String mensagemEsperada = "Não há registros";
        cadastroServicoFlows.apagaPontoEntrega();
        Assert.assertTrue(cadastroServicoPage.validaExclusao().contains(mensagemEsperada));

    }

    @Test
    public void excluirEmbalagem() {
        navegaServico();
        String mensagemEsperada = "Não há registros";
        cadastroServicoFlows.excluirEmbalagem();
        Assert.assertTrue(cadastroServicoPage.validaExclusao().contains(mensagemEsperada));
    }


}
